#include <stdio.h>
#include <math.h>
#include "cephes.h"
#include "dict.h"

#define BIN_SIZE 10
static int freqPerBin[BIN_SIZE];

void add_sample(double pval)
{
    //printf("pval:%f\n", pval);
    install(pval);
    int pos = (int)floor(pval*BIN_SIZE);
    if ( pos == BIN_SIZE )
        pos--;
    freqPerBin[pos]++; 
}

static FILE *hist;
void hist_print(double pval, int count)
{
    fprintf(hist, "%.9f %d\n", pval, count);
}

void print_histogram(int sampleSize)
{
    double chi2 = 0.0;
    double uniformity;
    double expCount = sampleSize/BIN_SIZE;
    int j;
    if ( expCount == 0 )
        uniformity = 0.0;
    else {
        for ( j=0; j<BIN_SIZE; j++ )
            chi2 += pow(freqPerBin[j]-expCount, 2)/expCount;
        uniformity = cephes_igamc((((float)BIN_SIZE)-1)/2.0, chi2/2.0);
    }
        
    for ( j=0; j<BIN_SIZE; j++ )          /* DISPLAY RESULTS */
        printf("%3d ", freqPerBin[j]);
    if ( expCount == 0 )
        printf("    ----    ");
    else if ( uniformity < 0.0001 )
        printf(" %8.6f * ", uniformity);
    else
        printf(" %8.6f   ", uniformity);
    printf("\n");
    printf("\n");

    hist = fopen("histogram.txt", "w");
    keys(hist_print);
    fclose(hist);
}

